C	THE GARBAGE CAN MODEL. VERSION 5
C	***
C	IO IS 1 FOR SUMMARY STATISTICS ONLY
C	IO IS 2 FOR SUMMARY STATISTICS PLUS HISTORIES
C	***
C	NA IS 1 WHEN PROBS AND DMKRS BOTH MOVE
C	NA IS 2 WHEN DMKRS ONLY MOVE
C	NA IS 3 WHEN PROBS ONLY MOVE
C	NA IS 4 WHEN NEITHER PROBS NOR DMKRS MOVE
C	***
C	IL IS A FACTOR DETERMINING PROB ENERGY REQ
C	***
C	VARIABLES
C		***
C		NUMBERS
C			COUNTERS	UPPER LIMITS	NAME
C			***
C			I		NCH		CHOICES
C			J		NPR		PROBLEM
C			K		NDM		DECMKRS
C			LT		NTP		TIME
C		***
C		ARRAYS
C			CODE		DIMEN		NAME
C			***
C			ICH		NCH		CHOICE ENTRY TIME
C			ICS		NCH		ENTRY STATUS
C			JET		NPR		PROB. ENTRY TIME
C			JF		NPR		PROB. ATT. CHOICE
C			JFF		NPR		WORKING COPY JF
C			JPS		NPR		PROB. STATUS
C			KDC		NDM		DMKR. ATT. CHOICE
C			KDCW		NDM		WORKING COPY KDC
C			XEF		MCH		ENERGY EXPENDED
C			XERC		NCH		CHOICE EN. REQT.
C			XERP		NPR		PROB. EN. REQT.
C			XSC		NTP		SOLUTION COEFFICIENT
C		***
C		2-DIMENSIONAL ARRAYS
C			***
C			CODE		DIMEN		NAME
C			***
C			IKA		NCH.NDM		DECISION STRUCTURE
C			JIA		NPR.NCH		ACCESS STRUCTURE
C			XEA		NDM.NTP		ENERGY MATRIX
C		***
C		***
C		***
C	***
C	SUMMARY STATISTICS FOR EACH VARIANT
C			COL 1: KZ: TOTAL DECISIONS NOT MADE
C			COL 2: KY: TOTAL NUMBER ACTIVE CHOICE PERIODS
C			COL 3: KX: TOTAL NUMBER CHANGES BY DECISION MAKERS
C			COL 4: KW: TOTAL PROBLEMS NOT SOLVED
C			COL 5: KV: TOTAL NUMBER CHANGES BY PROBLEMS
C			COL 6: KU: TOTAL NUMBER LATENT PROBLEM PERIODS
C			COL 7: KT: TOTAL NUMBER ATTACHED PROBLEM PERIODS
C			COL 8: KS: TOTAL NUMBER PERIODS DMKRS RESTING
C			COL 9: XR: TOTAL AMOUNT OF UNUSED ENERGY
C			COL 10:XS: TOTAL AMOUNT OF WASTED ENERGY
C	***
C	INPUT BLOCK. READ-IN AND INITIALIZATIONS.
	DIMENSION ICH(20),JF(20),XERC(20),XEE(20),XSC(20),JFF(20),XERP(20),JET(20),JPS(20),ICS(20),KDC(20),KDCW(20),JIA(20,20),IKA(20,20),CXEA(20,20),KABC(20,20),KBBC(20,20),KCBC(20,20)
1001	FORMAT(5(I3,1X))
1002	FORMAT(10(I3,1X))
1003	FORMAT(25(I1,1X))
1004	FORMAT(10F4.2)
	NTP = 20
	NCH = 10
	NPR = 20
	NDM = 10
8	READ(5,1002)(ICH(I),I = 1,NCH)
	READ(5,1004)(XSC(LT),LT = 1,NTP)
	READ(5,1002)(JET(J),J = 1,NPR)
	READ(5,1003) NA,IO
	WRITE(6,1050) NA
1050	FORMAT('1	DEC.MAKER MOVEMENT CONDITION (NA) IS ',I1/)
	DO 998 IL = 1.3
	IB = IL - 1
	DO 997 JAB = 1,3
	JA = JAB - 1
	DO 996 JDB = 1,3
	JD = JDB - 1
	DO 995 JEB = 1,3
	JE = JEB - 1
	XR = 0.0
	XS = 0.0
	KS = 0
	DO 10 I = 1,NCH
	XERC(I) = 1.1
	XEE(I) = 0.0
10	ICS(I) = 0
	DO 20 K = 1,NDM
	KDC(K) = 0
20	KDCW(K) = KDC(K)
	DO 40 J = 1,NPR
	XERP(J) = IL*1.1
	JF(J) = 0
	JFF(J) = 0
40	JPS(J) = 0
C	SETTING UP THE DECISION MAKERS ACCESS TO CHOICES
	DO 520 I = 1,NCH
	DO 510 J = 1,NDM
	IKA(I,J) = 1
	IF (JD.EQ.1) GO TO 502
	IF (JD.EQ.2) GO TO 504
	GO TO 510
502	IF (I.GE.J) GO TO 510
	IKA(I,J) = 0
	GO TO 510
504	IF (J.EQ.I) GO TO 510
	IKA(I,J) = 0
510	CONTINUE
520	CONTINUE
C	SETTING UP THE PROBLEMS ACCESS TO CHOICES.
	DO 560 I = 1,NPR
	DO 550 J = 1,NCH
	JIA(I,J) = 0
	IF (JA.EQ.1) GO TO 532
	IF (JA.EQ.2) GO TO 534
	JIA(I,J) = 1
	GO TO 550
532	IF ((I - J).GT.(I/2)) GO TO 550
	JIA(I,J) = 1
	GO TO 550
534	IF (I.NE.(2*J)) GO TO 550
	JIA(I,J) = 1
	JIA(I-1,J) = 1
550	CONTINUE
560	CONTINUE
	DO 590 I = 1,NDM
	DO 580 J = 1,NTP
	XEA(I,J) = 0.55
	IF (JF.EQ.1) GO TO 580
	XXA = I
	IF (JE.EQ.0) GO TO 570
	XEA(I,J) = (11.0 - XXA)/10.0
	GO TO 580
570	XEA(I,J) = XXA/10.0
580	CONTINUE
590	CONTINUE
C	*** FINISH READ	 INITIALIZATION
	DO 994 LT = 1,NTP
1006	FORMAT(2X.6HCHOICE,2X,I3,2X.6HACTIVE)
C	CHOICE ACTIVATION
	DO 101 I = 1,NCH
	IF (ICH(I).NE.LT) GO TO 101
	ICS(I) = 1
101	CONTINUE
C	PROB. ACTIVATION
	DO 110 J = I,NPR
	IF (JET(J).NE.LT) GO TO 110
	JPS(J) = 1
110	CONTINUE
C	FIND MOST ATTRACTIVE CHOICE FOR PROBLEM J
	DO 120 J = 1,NPR
	IF (JPS(J).NE.1) GO TO 120
	IF (NA.EQ.2) GO TO 125
	IF (NA.EQ.4) GO TO 125
	GO TO 126
125	IF (JF(J).NE.0) GO TO 127
126	S = 1000000
	DO 121 I = 1,NCH
	IF (ICS(I).NE.1) GO TO 121
	IF (JIA(J.I)EQ.0) GO TO 121
	IF (JF(J).EQ.0) GO TO 122
	IF (JF(J).EQ.1) GO TO 122
	IF ((XERP(J) + XERC(I) - XEE(I)).GE.S) GO TO 121
	GO TO 123
122	IF ((XERC(I) - XEE(I)).GE.S) GO TO 121
	S = XERC(I) - XEE(I)
	GO TO 124
123	S = XERP(J) + XERC(I) - XEE(I)
124	JFF(J) = I
121	CONTINUE
	GO TO 120
127	JFF(J) = JF(J)
120	CONTINUE
	DO 130 J = 1,NPR
131	JF(J) = JFF(J)
130	JFF(J) = 0
	LTT = LT - 1
	IF (LT.EQ.1) LTT = 1
C	FIND MOST ATTRACTIVE CHOICE FOR DMKR K
	DO 140 K = 1,NDM
	IF (NA.EQ.3) GO TO 145
	IF (NA.EQ.4) GO TO 145
	GO TO 146
145	IF (KDC(K).NE.0) GO TO 147
146	S = 1000000
	DO 141 I = 1,NCH
	IF (ICS(I).NE.1) GO TO 141
	IF (IKA(I.K).EQ.0) GO TO 141
	IF (KDC(K).EQ.0) GO TO 142
	IF (KDC(K).EQ.1) GO TO 142
148	IF ((XFRC(I) - XEE(I) - (XEA(K,LTT)*XSC(LTT))).GE.S) GO TO 141
	GO TO 143
142	IF ((XERC(I) - XEE(I)).GE.S) GO TO 141
	S = XERC(I) - XEE(I)
	GO TO 144
143	S = XERC(I) - XEE(I) - XEA(K,LTT)*XSC(LTT)
144	KDCW(K) = I
141	CONTINUE
	GO TO 140
147	KDCW(K) = KDC(K)
140	CONTINUE
	DO 150 K = 1,NDM
151	KDC(K) = KDCW(K)
	IF (KDC(K).NE.0) GO TO 150
	XR = XR + (XEA(K,LT)*XSC(LT))
	KS = KS + 1
150	KDCW(K) = 0
C	ESTABLISHING THE ENERGY REQUIRED TO MAKE EACH CHOICE.
	DO 199 I = 1,NCH
	IF (ICS(I).EQ.0) GO TO 199
	XERC(I) = 0.0
	DO 160 J = 1,NPR
	IF (JPS(J).NE.1) GO TO 160
	IF (JF(J).NE.I) GO TO 160
	XERC(I) = XERC(I) + XERP(J)
160	CONTINUE
	DO 170 K = 1,NDM
	IF (IKA(I.K).EQ.0) GO TO 170
	IF (KDC(K).NE.I) GO TO 170
	XEE(I) = XEE(I) + XSC(LT)*XEA(K,LT)
170	CONTINUE
199	CONTINUE
C	MAKING DECISIONS
	DO 299 I = 1,NCH
	IF (ICS(I).NE.1) GO TO 299
	IF (XERC(I).GT.XEE(I)) GO TO 299
	XS = XS + XEE(I) - XERC(I)
	ICS(I) = 2
	DO 250 J = 1,NPR
	IF (JF(J).NE.I) GO TO 250
	JPS(J) = 2
250	CONTINUE
	IF (NA.EQ.3) GO TO 261
	IF (NA.EQ.4) GO TO 261
	GO TO 299
261	DO 262 K = 1,NDM
	IF (KDC(K).NE.I) GO TO 262
	KDCW(K) = 1
262	CONTINUE
299	CONTINUE
	DO 200 I = 1,NCH
200	KABC(LT.I) = ICS(I)
	DO 210 K = 1,NDM
	KBBC(LT,K) = KDC(K)
	IF (KDCW(K).EQ.0) GO TO 210
	KDC(K) = 0
210	KDCW(K) = 0
	DO 220 J = 1,NPR
	KCBC(LT,J) = JF(J)
	IF (JPS(J).EQ.0) GO TO 230
	IF (JPS(J).EQ.1) GO TO 220
	KCBC(LT,J) = 1000
	GO TO 220
230	KCBC(LT,J) = -1
220	CONTINUE
994	CONTINUE
C	FINISH TIME PERIOD LOOP. BEGIN ACCUMULATION OF 10 SUMMARY STATISTICS.
	KZ = 0
	KY = 0
	KX = 0
	KW = 0
	KV = 0
	KU = 0
	KT = 0
	DO 310 I = 1,NTP
	DO 320 J = 1,NCH
	IF (KABC(I,J).NE.1) GO TO 320
	KY = KY + 1
	IF (I.NE.NTP) GO TO 320
	KZ = KZ + 1
320	CONTINUE
310	CONTINUE
	DO 330	I = 2,NTP
	DO 340 J = 1,NDM
	IF (KBBC(I,J).EQ.KBBC(I-1,J) GO TO 340
	KX = KX + 1
340	CONTINUE
330	CONTINUE
	DO 350	I = 1,NTP
	DO 360 J = 1,NPR
	IF (KCBC(I.J).EQ.0) GO TO 351
	IF (KCBC(I.J).EQ.-1) GO TO 360
	IF (KCBC(I.J).EQ.1000) GO TO 352
	KT = KT + 1
	GO TO 360
351	KU = KU + 1
	GO TO 360
352	IF (I.NE.NTP) GO TO 360
	KW = KW + 1
360	CONTINUE
350	CONTINUE
	KW = NPR - KW
	DO 370 I = 2,NTP
	DO 380 J = 1,NPR
	IF (KCBC(I,J).EQ.KCBC(I-1,J)) GO TO 380
	KV = KV + 1
380	CONTINUE
370	CONTINUE
C	BEGIN WRITEOUT OF MATERIALS FOR THIS ORGANIZATIONAL VARIANT.
1000	FORMAT(1H1)
1019	FORMAT(2X,'LOAD=',I1,'PR.ACC.=',I1,'DEC.STR.=',I1,'EN.DIST.='.BI1,2X,'STATS I-10',3X,8I5,1X,2F6.2/)
	WRITE(6,1019)IB,JA,JD,JE,KZ,KY,KX,KW,KV,KY,KT,KS,ZR,XS
	IF (IO.EQ.1) GO TO 995
2000	FORMAT(' CHOICE ACTIVATION HISTORY',34X,'DEC.MAKER ACTIVITY HISTORY BY'/'20 TIME PERIODS, 10 CHOICES',33X,'20 TIME PERIODS, 10 DEC. MAKE CRS'/' 0 = INACTIVE, 1 = ACTIVE, 2 = MADE',33X,'0 = INACTIVE, X = WORHING ON CHODICE X'//9X,'  1 2 3 4 5 6 7 8 9 10',30X,'1 2 3 4 5 6 7 8 9 10'/)
	WRITE(6,2000)
2001	FORMAT( 5X,I2,3X,10I2,25X,12,3X,10I2)
	WRITE(6,2001)(LT,(KABC(LT,J),J=1,NCH),LT,( KBBC(LT,J),J=1,NDM), LT = 1,NTP)
2002	FORMAT(/' PROBLEM HISTORY:ROWS=TIME,COLS=PROBS., -1=NOT ENTERED,, O=UNATTACHED,X=ATT.TO CH.X,**=SOLVED'/1OX.
	' 1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20'/)
	WRITE(6,2002)
2003	FORMAT(20(5X,I2,3X,20(1X.I2)/))
	WRITE(6,2003)(LT,(KCBC(LT,J),J=1,NPR),LT=1,NTP)
	WRITE(6,1000)
995	CONTINUE
996	CONTINUE
997	CONTINUE
998	CONTINUE
	STOP
	END
